diff --git a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
rename to src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
index 21723967b..5a7ac953a 100644
--- a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
@@ -2,11 +2,11 @@ package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.FallingBlockEntity;
+import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
@@ -18,12 +18,12 @@ import net.minecraft.core.world.WorldSource;
 import java.util.ArrayList;
 import java.util.List;
 
-public class SteelPistonBaseBlock extends PistonBaseBlock{
+public class BlockPistonBaseSteel extends BlockPistonBase {
     public static final double HEAD_THICKNESS_STEEL = 6/16d;
 
     private Entity flungBlock = null;
 
-    public SteelPistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks) {
+    public BlockPistonBaseSteel(String key, String namespaceId, int id, int maxPushedBlocks) {
         super(key, namespaceId, id, maxPushedBlocks);
     }
 
@@ -104,20 +104,20 @@ public class SteelPistonBaseBlock extends PistonBaseBlock{
             Block block = world.getBlock(xo, yo, zo);
             if (block == null) return true;
             int blockMeta = world.getBlockMetadata(xo, yo, zo);
-            BlockEntity blockEntity = world.getBlockEntity(xo, yo, zo);
+            TileEntity tileEntity = world.getBlockEntity(xo, yo, zo);
             world.removeBlockTileEntity(xo, yo, zo);
             world.setBlockWithNotify(xo, yo, zo, 0);
-            FallingBlockEntity fallingBlockEntity = new FallingBlockEntity(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id, blockMeta, blockEntity);
-            fallingBlockEntity.hasRemovedBlock = true;
-            if (blockEntity instanceof IVehicle) {
-                Entity rider = ((IVehicle) blockEntity).getPassenger();
-                ((IVehicle) blockEntity).ejectRider();
-                if (rider != null) rider.startRiding(fallingBlockEntity);
+            EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id, blockMeta, tileEntity);
+            entityFallingBlock.hasRemovedBlock = true;
+            if (tileEntity instanceof IVehicle) {
+                Entity rider = ((IVehicle) tileEntity).getPassenger();
+                ((IVehicle) tileEntity).ejectRider();
+                if (rider != null) rider.startRiding(entityFallingBlock);
             }
-            world.entityJoinedWorld(fallingBlockEntity);
+            world.entityJoinedWorld(entityFallingBlock);
             final double speed = 2;
-            fallingBlockEntity.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
-            flungBlock = fallingBlockEntity;
+            entityFallingBlock.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
+            flungBlock = entityFallingBlock;
         }
         return true;
     }
@@ -149,8 +149,8 @@ public class SteelPistonBaseBlock extends PistonBaseBlock{
 
     @Override
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STEEL, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD_STEEL.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STEEL, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STEEL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
similarity index 67%
rename from src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java
rename to src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
index 4235a74b1..de5268130 100644
--- a/src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
@@ -2,44 +2,44 @@ package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
-public class StickyPistonBaseBlock extends PistonBaseBlock {
-    public StickyPistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks) {
+public class BlockPistonBaseSticky extends BlockPistonBase {
+    public BlockPistonBaseSticky(String key, String namespaceId, int id, int maxPushedBlocks) {
         super(key, namespaceId, id, maxPushedBlocks);
     }
 
     @Override
     public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
-        BlockEntity blockEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
-        if((blockEntity instanceof MovingPistonBlockEntity))
+        TileEntity tileEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
-            MovingPistonBlockEntity moving = ((MovingPistonBlockEntity) blockEntity);
+            TileEntityMovingPistonBlock moving = ((TileEntityMovingPistonBlock) tileEntity);
             if (!moving.isExtending()) {
-                ((MovingPistonBlockEntity)blockEntity).finalTick();
+                ((TileEntityMovingPistonBlock) tileEntity).finalTick();
             } else {
                 world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
             }
         }
         world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
-        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction.getId(), null, direction, false, true));
+        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id, direction.getId(), null, direction, false, true));
         int x1 = x + direction.getOffsetX() * 2;
         int y1 = y + direction.getOffsetY() * 2;
         int z1 = z + direction.getOffsetZ() * 2;
         int retractId = world.getBlockId(x1, y1, z1);
         int retactMeta = world.getBlockMetadata(x1, y1, z1);
-        BlockEntity retractEntity = world.getBlockEntity(x1, y1, z1);
+        TileEntity retractEntity = world.getBlockEntity(x1, y1, z1);
         boolean pulledMoving = false;
         if(retractId == Blocks.PISTON_MOVING.id)
         {
-            BlockEntity blockEntity1 = world.getBlockEntity(x1, y1, z1);
-            if((blockEntity1 instanceof MovingPistonBlockEntity))
+            TileEntity tileEntity1 = world.getBlockEntity(x1, y1, z1);
+            if((tileEntity1 instanceof TileEntityMovingPistonBlock))
             {
-                MovingPistonBlockEntity movingPistonBlock = (MovingPistonBlockEntity)blockEntity1;
+                TileEntityMovingPistonBlock movingPistonBlock = (TileEntityMovingPistonBlock) tileEntity1;
                 if(movingPistonBlock.getDirection() == direction && movingPistonBlock.isExtending())
                 {
                     movingPistonBlock.finalTick();
@@ -52,9 +52,9 @@ public class StickyPistonBaseBlock extends PistonBaseBlock {
         }
         if(!pulledMoving && retractId > 0 &&
             isPushable(retractId, world, x1, y1, z1, false) &&
-            (Block.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Block.getBlock(retractId) instanceof PistonBaseBlock)))
+            (Block.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Block.getBlock(retractId) instanceof BlockPistonBase)))
         {
-            if (!(retractEntity instanceof MovingPistonBlockEntity)) {
+            if (!(retractEntity instanceof TileEntityMovingPistonBlock)) {
                 world.removeBlockTileEntity(x1, y1, z1);
             }
             world.setBlock(x1, y1, z1, 0);
@@ -62,7 +62,7 @@ public class StickyPistonBaseBlock extends PistonBaseBlock {
             y += direction.getOffsetY();
             z += direction.getOffsetZ();
             world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, retactMeta);
-            world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
+            world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
             world.notifyBlockChange(x1, y1, z1, 0);
         } else
         if(!pulledMoving)
@@ -73,7 +73,7 @@ public class StickyPistonBaseBlock extends PistonBaseBlock {
     }
     @Override
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STICKY, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STICKY, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STICKY, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
rename to src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
index 44be3cf3f..1abe9c8c7 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
@@ -4,18 +4,17 @@ import java.util.ArrayList;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class PistonHeadBlock extends Block
+public class BlockPistonHead extends Block
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_TYPE = 0b1111_1000;
@@ -24,7 +23,7 @@ public class PistonHeadBlock extends Block
     public static final int TYPE_STEEL = 2;
 
     private final double headThickness;
-    public PistonHeadBlock(String key, String namespaceId, int id, double headThickness)
+    public BlockPistonHead(String key, String namespaceId, int id, double headThickness)
     {
         super(key, namespaceId, id, Material.piston);
         withHardness(0.5F);
@@ -44,10 +43,10 @@ public class PistonHeadBlock extends Block
         int y2 = y + orientation.getOffsetY();
         int z2 = z + orientation.getOffsetZ();
         Block block = world.getBlock(x2, y2, z2);
-        if(block instanceof PistonBaseBlock)
+        if(block instanceof BlockPistonBase)
         {
             int data2 = world.getBlockMetadata(x2, y2, z2);
-            if(PistonBaseBlock.isPowered(data2))
+            if(BlockPistonBase.isPowered(data2))
             {
                 block.dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x2, y2, z2, data2, null, null);
                 world.setBlockWithNotify(x2, y2, z2, 0);
@@ -170,7 +169,7 @@ public class PistonHeadBlock extends Block
         	return;
         }
         Block block = world.getBlock(x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ());
-        if (block instanceof PistonBaseBlock) {
+        if (block instanceof BlockPistonBase) {
             block.onNeighborBlockChange(world, x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ(), blockId);
         } else {
             world.setBlockWithNotify(x, y, z, 0);
@@ -196,7 +195,7 @@ public class PistonHeadBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK)
         {
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
rename to src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
index 931c1e5b8..9cf193d4b 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.EntityBlock;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.BlockTileEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -14,16 +14,16 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import org.jetbrains.annotations.Nullable;
 
-public class MovingPistonBlock extends EntityBlock
+public class BlockPistonMoving extends BlockTileEntity
 {
-    public MovingPistonBlock(String key, String namespaceId, int id)
+    public BlockPistonMoving(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.piston);
         withHardness(-1F);
     }
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
         return null;
     }
@@ -36,10 +36,10 @@ public class MovingPistonBlock extends EntityBlock
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-        if((blockEntity instanceof MovingPistonBlockEntity))
+        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
-            ((MovingPistonBlockEntity)blockEntity).finalTick();
+            ((TileEntityMovingPistonBlock) tileEntity).finalTick();
         } else
         {
             super.onBlockRemoved(world, x, y, z, data);
@@ -76,7 +76,7 @@ public class MovingPistonBlock extends EntityBlock
         if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
         {
             int id = 0;
-            MovingPistonBlockEntity piston = getBlockEntity(world, x, y, z);
+            TileEntityMovingPistonBlock piston = getBlockEntity(world, x, y, z);
             if (piston != null) id = piston.getMovedId();
             world.setBlockWithNotify(x, y, z, id);
             return true;
@@ -87,19 +87,19 @@ public class MovingPistonBlock extends EntityBlock
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return null;
     }
 
     @Override
-    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity, Player player)
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player)
     {
         if(world.isClientSide)
         {
             return;
         }
-        MovingPistonBlockEntity piston = getBlockEntity(world, x, y, z);
+        TileEntityMovingPistonBlock piston = getBlockEntity(world, x, y, z);
         if(piston != null)
         {
             Block.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
@@ -115,16 +115,16 @@ public class MovingPistonBlock extends EntityBlock
         }
     }
 
-    public static BlockEntity createTileEntity(int movedId, int movedData, @Nullable BlockEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
+    public static TileEntity createTileEntity(int movedId, int movedData, @Nullable TileEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
     {
-        assert !(movedEntity instanceof MovingPistonBlockEntity) : "Moving piston entity should not be able to be put into another moving piston!";
-        return new MovingPistonBlockEntity(movedId, movedData, movedEntity, direction, extending, isSourcePiston);
+        assert !(movedEntity instanceof TileEntityMovingPistonBlock) : "Moving piston entity should not be able to be put into another moving piston!";
+        return new TileEntityMovingPistonBlock(movedId, movedData, movedEntity, direction, extending, isSourcePiston);
     }
 
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        MovingPistonBlockEntity tileEntity = getBlockEntity(world, x, y, z);
+        TileEntityMovingPistonBlock tileEntity = getBlockEntity(world, x, y, z);
         if(tileEntity == null)
         {
             return null;
@@ -140,7 +140,7 @@ public class MovingPistonBlock extends EntityBlock
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        MovingPistonBlockEntity pistonBlockEntity = getBlockEntity(world, x, y, z);
+        TileEntityMovingPistonBlock pistonBlockEntity = getBlockEntity(world, x, y, z);
         if(pistonBlockEntity != null)
         {
             Block block = Block.blocksList[pistonBlockEntity.getMovedId()];
@@ -186,12 +186,12 @@ public class MovingPistonBlock extends EntityBlock
         }
     }
 
-    private MovingPistonBlockEntity getBlockEntity(WorldSource world, int x, int y, int z)
+    private TileEntityMovingPistonBlock getBlockEntity(WorldSource world, int x, int y, int z)
     {
-        BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-        if(blockEntity instanceof MovingPistonBlockEntity)
+        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        if(tileEntity instanceof TileEntityMovingPistonBlock)
         {
-            return (MovingPistonBlockEntity) blockEntity;
+            return (TileEntityMovingPistonBlock) tileEntity;
         }
         else
         {
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
rename to src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 30de4c93f..474e0b9fb 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.BlockEntityDispatcher;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -13,14 +13,14 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
-public class MovingPistonBlockEntity extends BlockEntity
+public class TileEntityMovingPistonBlock extends TileEntity
 {
     public static final int TICKS_TO_EXTEND = 2;
     private static final List<Entity> entityBuffer = new ArrayList<>();
 
     private int movedId;
     private int movedData;
-    private @Nullable BlockEntity movedEntity;
+    private @Nullable TileEntity movedEntity;
     private Direction direction;
     private boolean extending;
     private boolean isSourcePiston;
@@ -28,11 +28,11 @@ public class MovingPistonBlockEntity extends BlockEntity
     private float progressO;
 
     @SuppressWarnings("unused")
-    public MovingPistonBlockEntity()
+    public TileEntityMovingPistonBlock()
     {
     }
 
-    public MovingPistonBlockEntity(int movedId, int movedData, @Nullable BlockEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
+    public TileEntityMovingPistonBlock(int movedId, int movedData, @Nullable TileEntity movedEntity, Direction direction, boolean extending, boolean isSourcePiston)
     {
         this.movedId = movedId;
         this.movedData = movedData;
@@ -53,7 +53,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         return movedData;
     }
 
-    public @Nullable BlockEntity getMovedEntity() {
+    public @Nullable TileEntity getMovedEntity() {
         return movedEntity;
     }
 
@@ -123,7 +123,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         {
             stretch = 1.0F - stretch;
         }
-        AABB aabb = ((MovingPistonBlock) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, stretch, direction);
+        AABB aabb = ((BlockPistonMoving) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, stretch, direction);
         if (aabb == null) return;
 
         List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
@@ -146,7 +146,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
             worldObj.setBlockAndMetadataRaw(x, y, z, movedId, movedData);
             if (movedEntity != null) {
-                BlockEntity oldEnt = worldObj.getBlockEntity(x, y, z);
+                TileEntity oldEnt = worldObj.getBlockEntity(x, y, z);
                 if (oldEnt != null) {
                     oldEnt.invalidate();
                 }
@@ -190,9 +190,9 @@ public class MovingPistonBlockEntity extends BlockEntity
         super.readFromNBT(tag);
         movedId = tag.getInteger("blockId");
         movedData = tag.getInteger("blockData");
-        if (tag.containsKey("blockEntity")) {
-            CompoundTag entityTag = tag.getCompound("blockEntity");
-            movedEntity = BlockEntityDispatcher.createAndLoadEntity(entityTag);
+        if (tag.containsKey("tileEntity")) {
+            CompoundTag entityTag = tag.getCompound("tileEntity");
+            movedEntity = TileEntityDispatcher.createAndLoadEntity(entityTag);
         }
         direction = Direction.getDirectionById(tag.getInteger("facing"));
         progressO = progress = tag.getFloat("progress");
@@ -208,7 +208,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         if (movedEntity != null) {
             CompoundTag entityTag = new CompoundTag();
             movedEntity.writeToNBT(entityTag);
-            tag.put("blockEntity", entityTag);
+            tag.put("tileEntity", entityTag);
         }
         tag.putInt("facing", direction.getId());
         tag.putFloat("progress", progressO);
